image: gabsdevops/docker-cicd
services:
  - docker:dind

stages:
  - unit_test
  - build
  - release
  - deploy

variables: 
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  GITLAB_REGISTER: registry.gitlab.com/gabriel.dantas/fut-rex 
  ECR_REGISTER: 485164690107.dkr.ecr.us-east-1.amazonaws.com/fut-rex

before_script:
  - export AWS_ACCESS_KEY_ID=$AWS_ACCESS_KEY_ID
  - export AWS_SECRET_ACCESS_KEY=$AWS_SECRET_ACCESS_KEY
  - export AWS_DEFAULT_REGION=us-east-1
  - echo ${CI_COMMIT_SHA:0:8}
#- echo "$REGISTER_PASSWORD" | docker login registry.gitlab.com -u "$REGISTER_USER" --password-stdin
  -  $(aws ecr get-login --no-include-email --region us-east-1)

unit_test:
  stage: unit_test
  tags:
    - gb-runner
  script:
    - pip install -r requirements.txt
    - pytest tests

build:
  stage: build
  tags: 
    - gb-runner
  script:
    - docker build --pull -t $ECR_REGISTER:$CI_COMMIT_SHA .
    - docker push $ECR_REGISTER:$CI_COMMIT_SHA

release-image:
  stage: release
  tags:
    - gb-runner
  script:
    - docker pull $ECR_REGISTER:$CI_COMMIT_SHA
    - docker tag $ECR_REGISTER:$CI_COMMIT_SHA $ECR_REGISTER:latest
    - docker push $ECR_REGISTER:latest
  only:
    - master

deploy:
  stage: deploy
  tags: 
    - gb-runner
  script:
    - echo "Executando processo de deploy da nova versão ${CI_COMMIT_SHA:0:8}"
  only:
    - master